package org.netkernel.xml.accessor.schema;

import javax.xml.XMLConstants;
import javax.xml.transform.Source;
import javax.xml.transform.stream.StreamSource;
import javax.xml.validation.Schema;
import javax.xml.validation.SchemaFactory;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.IReadableBinaryStreamRepresentation;
import org.netkernel.module.standard.endpoint.StandardTransreptorImpl;
import org.netkernel.xml.util.NKFLSResourceResolver;

public class XSDSchemaCompiler extends StandardTransreptorImpl
{
	public XSDSchemaCompiler()
	{	this.declareThreadSafe();
		this.declareToRepresentation(XSDSchemaRep.class);
	}

	@Override
	public void onTransrept(INKFRequestContext context) throws Exception
	{	IReadableBinaryStreamRepresentation s=(IReadableBinaryStreamRepresentation)context.sourcePrimary( IReadableBinaryStreamRepresentation.class);
		String id=context.getThisRequest().getIdentifier();
		if(context.getCWU()==null)
		{	context.setCWU(id);			
		}
    	SchemaFactory factory = SchemaFactory.newInstance(XMLConstants.W3C_XML_SCHEMA_NS_URI);
    	factory.setResourceResolver(new NKFLSResourceResolver(context));
    	Source schemaFile = new StreamSource(s.getInputStream(), id);
    	Schema schema = factory.newSchema(schemaFile);
    	context.createResponseFrom(new XSDSchemaRep(schema));
	}
}
